// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	openapi_types "github.com/oapi-codegen/runtime/types"
)

// Defines values for ClaimKind.
const (
	Assertion          ClaimKind = "Assertion"
	Correction         ClaimKind = "Correction"
	ExpireRegistration ClaimKind = "ExpireRegistration"
	ExpireValid        ClaimKind = "ExpireValid"
	Refutation         ClaimKind = "Refutation"
	Validation         ClaimKind = "Validation"
)

// Defines values for OperationType.
const (
	StelNaamIn OperationType = "StelNaamIn"
)

// Claim A claim including its data
type Claim struct {
	// AssociatedClaim The claims id
	AssociatedClaim *ClaimID `json:"associatedClaim,omitempty"`

	// ClaimKind The claim kind
	ClaimKind ClaimKind `json:"claim_kind"`

	// ClaimType The claim type
	ClaimType ClaimTypeName `json:"claim_type"`

	// Claimant The id of the entity making the claim
	Claimant ClaimantID `json:"claimant"`

	// Data The data object of a claim
	Data ClaimData `json:"data"`

	// RegistrationStart A date/time moment in ISO8601
	RegistrationStart Date `json:"registrationStart"`

	// Subject The id of the entity that is the subject of the claim
	Subject SubjectID `json:"subject"`

	// ValidStart A date/time moment in ISO8601
	ValidStart *Date `json:"validStart,omitempty"`
}

// ClaimFindData defines model for ClaimFindData.
type ClaimFindData struct {
	AnnotatingClaims *[]AnnotatingClaimData `json:"annotatingClaims,omitempty"`

	// AssociatedClaim The claims id
	AssociatedClaim *ClaimID `json:"associatedClaim,omitempty"`

	// AssociatedOperation The operations id
	AssociatedOperation *OperationID `json:"associatedOperation,omitempty"`

	// ClaimKind The claim kind
	ClaimKind ClaimKind `json:"claim_kind"`

	// ClaimType The claim type
	ClaimType ClaimTypeName `json:"claim_type"`

	// Claimant The id of the entity making the claim
	Claimant ClaimantID `json:"claimant"`

	// Data The data object of a claim
	Data ClaimData `json:"data"`

	// Id The claims id
	Id *ClaimID `json:"id,omitempty"`

	// RegistrationEnd A date/time moment in ISO8601
	RegistrationEnd *Date `json:"registrationEnd,omitempty"`

	// RegistrationStart A date/time moment in ISO8601
	RegistrationStart Date `json:"registrationStart"`

	// Subject The id of the entity that is the subject of the claim
	Subject SubjectID `json:"subject"`

	// ValidEnd A date/time moment in ISO8601
	ValidEnd *Date `json:"validEnd,omitempty"`

	// ValidStart A date/time moment in ISO8601
	ValidStart *Date `json:"validStart,omitempty"`
}

// ClaimType A claim type including its schema definition
type ClaimType struct {
	// Name The claim type
	Name   ClaimTypeName          `json:"name"`
	Schema map[string]interface{} `json:"schema"`

	// ValidEnd A date/time moment in ISO8601
	ValidEnd *Date `json:"validEnd,omitempty"`

	// ValidStart A date/time moment in ISO8601
	ValidStart *Date `json:"validStart,omitempty"`
}

// CreateClaimData The data returned after creating a claim
type CreateClaimData struct {
	// Id The claims id
	Id ClaimID `json:"id"`
}

// CreateClaimTypeData The data returned after creating a claim type
type CreateClaimTypeData struct {
	// Id The claim type id
	Id ClaimTypeID `json:"id"`
}

// CreateOperationData The data returned after creating an operation
type CreateOperationData struct {
	// Id The operations id
	Id OperationID `json:"id"`
}

// Error The error that occurred while processing this request.
type Error struct {
	Message string `json:"message"`
}

// FindClaimData The list of found claims
type FindClaimData = []ClaimFindData

// Operation A collection of related claims
type Operation struct {
	// Claimant The id of the entity making the claim
	Claimant ClaimantID `json:"claimant"`
	Claims   []Claim    `json:"claims"`

	// OperationType The operation type
	OperationType OperationType `json:"operationType"`

	// RegistrationStart A date/time moment in ISO8601
	RegistrationStart Date `json:"registrationStart"`

	// ValidStart A date/time moment in ISO8601
	ValidStart Date `json:"validStart"`
}

// AnnotatingClaimData The kind of a claim
type AnnotatingClaimData struct {
	// Id The claims id
	Id *ClaimID `json:"id,omitempty"`

	// Kind The claim kind
	Kind *ClaimKind `json:"kind,omitempty"`
}

// ClaimData The data object of a claim
type ClaimData map[string]interface{}

// ClaimDataQuery json encoded object
type ClaimDataQuery = string

// ClaimID The claims id
type ClaimID = openapi_types.UUID

// ClaimKind The claim kind
type ClaimKind string

// ClaimTypeID The claim type id
type ClaimTypeID = openapi_types.UUID

// ClaimTypeName The claim type
type ClaimTypeName = string

// ClaimantID The id of the entity making the claim
type ClaimantID = openapi_types.UUID

// Date A date/time moment in ISO8601
type Date = time.Time

// OperationID The operations id
type OperationID = openapi_types.UUID

// OperationType The operation type
type OperationType string

// SubjectID The id of the entity that is the subject of the claim
type SubjectID = openapi_types.UUID

// QueryAssociatedClaim The claims id
type QueryAssociatedClaim = ClaimID

// QueryAssociatedOperation The operations id
type QueryAssociatedOperation = OperationID

// QueryClaimID The claims id
type QueryClaimID = ClaimID

// QueryClaimKind The claim kind
type QueryClaimKind = ClaimKind

// QueryClaimSubject The id of the entity that is the subject of the claim
type QueryClaimSubject = SubjectID

// QueryClaimType The claim type
type QueryClaimType = ClaimTypeName

// QueryClaimTypeRequired The claim type
type QueryClaimTypeRequired = ClaimTypeName

// QueryClaimant The id of the entity making the claim
type QueryClaimant = ClaimantID

// QueryData json encoded object
type QueryData = ClaimDataQuery

// QueryRegistrationEnd A date/time moment in ISO8601
type QueryRegistrationEnd = Date

// QueryRegistrationStart A date/time moment in ISO8601
type QueryRegistrationStart = Date

// QueryValidEnd A date/time moment in ISO8601
type QueryValidEnd = Date

// QueryValidEndRequired A date/time moment in ISO8601
type QueryValidEndRequired = Date

// QueryValidStart A date/time moment in ISO8601
type QueryValidStart = Date

// BadRequestErrorResponse defines model for BadRequestErrorResponse.
type BadRequestErrorResponse struct {
	Errors []Error `json:"errors"`
}

// ClaimCreateResponse defines model for ClaimCreateResponse.
type ClaimCreateResponse struct {
	// Data The data returned after creating a claim
	Data *CreateClaimData `json:"data,omitempty"`
}

// ClaimFindResponse defines model for ClaimFindResponse.
type ClaimFindResponse struct {
	// Data The list of found claims
	Data *FindClaimData `json:"data,omitempty"`
}

// ClaimTypeCreateResponse defines model for ClaimTypeCreateResponse.
type ClaimTypeCreateResponse struct {
	// Data The data returned after creating a claim type
	Data *CreateClaimTypeData `json:"data,omitempty"`
}

// EmptyResponse defines model for EmptyResponse.
type EmptyResponse = map[string]interface{}

// InternalServerError defines model for InternalServerError.
type InternalServerError struct {
	Errors []Error `json:"errors"`
}

// OperationCreateResponse defines model for OperationCreateResponse.
type OperationCreateResponse struct {
	// Data The data returned after creating an operation
	Data *CreateOperationData `json:"data,omitempty"`
}

// ClaimRequest defines model for ClaimRequest.
type ClaimRequest struct {
	// Input A claim including its data
	Input Claim `json:"input"`
}

// ClaimTypeRequest defines model for ClaimTypeRequest.
type ClaimTypeRequest struct {
	// Input A claim type including its schema definition
	Input ClaimType `json:"input"`
}

// OperationRequest defines model for OperationRequest.
type OperationRequest struct {
	// Input A collection of related claims
	Input Operation `json:"input"`
}

// FindClaimParams defines parameters for FindClaim.
type FindClaimParams struct {
	// ClaimID ID of claim to return.
	ClaimID *QueryClaimID `form:"claimID,omitempty" json:"claimID,omitempty"`

	// ClaimType Kind of type to return.
	ClaimType *QueryClaimType `form:"claimType,omitempty" json:"claimType,omitempty"`

	// ClaimKind Kind of claim to return.
	ClaimKind *QueryClaimKind `form:"claimKind,omitempty" json:"claimKind,omitempty"`

	// ClaimSubject ID of claim subject to return.
	ClaimSubject *QueryClaimSubject `form:"claimSubject,omitempty" json:"claimSubject,omitempty"`

	// Claimant claimant of the claim.
	Claimant *QueryClaimant `form:"claimant,omitempty" json:"claimant,omitempty"`

	// AssociatedOperation operation associated with the claim.
	AssociatedOperation *QueryAssociatedOperation `form:"associatedOperation,omitempty" json:"associatedOperation,omitempty"`

	// AssociatedClaim ID of claim that this claim references.
	AssociatedClaim *QueryAssociatedClaim `form:"associatedClaim,omitempty" json:"associatedClaim,omitempty"`

	// RegistrationStart the registration start date of the claim.
	RegistrationStart *QueryRegistrationStart `form:"registrationStart,omitempty" json:"registrationStart,omitempty"`

	// RegistrationEnd the registration end date of the claim.
	RegistrationEnd *QueryRegistrationEnd `form:"registrationEnd,omitempty" json:"registrationEnd,omitempty"`

	// ValidStart the valid start date of the claim.
	ValidStart *QueryValidStart `form:"validStart,omitempty" json:"validStart,omitempty"`

	// ValidEnd the valid end date of the claim.
	ValidEnd *QueryValidEnd `form:"validEnd,omitempty" json:"validEnd,omitempty"`

	// Data data objects to filter on
	Data *QueryData `form:"data,omitempty" json:"data,omitempty"`
}

// CreateClaimJSONBody defines parameters for CreateClaim.
type CreateClaimJSONBody struct {
	// Input A claim including its data
	Input Claim `json:"input"`
}

// ExpireClaimTypeParams defines parameters for ExpireClaimType.
type ExpireClaimTypeParams struct {
	// ClaimType Kind of type to return (required).
	ClaimType QueryClaimTypeRequired `form:"claimType" json:"claimType"`

	// ValidEnd the valid end date of the claim (required).
	ValidEnd QueryValidEndRequired `form:"validEnd" json:"validEnd"`
}

// CreateClaimTypeJSONBody defines parameters for CreateClaimType.
type CreateClaimTypeJSONBody struct {
	// Input A claim type including its schema definition
	Input ClaimType `json:"input"`
}

// CreateOperationJSONBody defines parameters for CreateOperation.
type CreateOperationJSONBody struct {
	// Input A collection of related claims
	Input Operation `json:"input"`
}

// CreateClaimJSONRequestBody defines body for CreateClaim for application/json ContentType.
type CreateClaimJSONRequestBody CreateClaimJSONBody

// CreateClaimTypeJSONRequestBody defines body for CreateClaimType for application/json ContentType.
type CreateClaimTypeJSONRequestBody CreateClaimTypeJSONBody

// CreateOperationJSONRequestBody defines body for CreateOperation for application/json ContentType.
type CreateOperationJSONRequestBody CreateOperationJSONBody

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// FindClaim request
	FindClaim(ctx context.Context, params *FindClaimParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateClaimWithBody request with any body
	CreateClaimWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateClaim(ctx context.Context, body CreateClaimJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ExpireClaimType request
	ExpireClaimType(ctx context.Context, params *ExpireClaimTypeParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateClaimTypeWithBody request with any body
	CreateClaimTypeWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateClaimType(ctx context.Context, body CreateClaimTypeJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// CreateOperationWithBody request with any body
	CreateOperationWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	CreateOperation(ctx context.Context, body CreateOperationJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ResetDatabase request
	ResetDatabase(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) FindClaim(ctx context.Context, params *FindClaimParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewFindClaimRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateClaimWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateClaimRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateClaim(ctx context.Context, body CreateClaimJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateClaimRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ExpireClaimType(ctx context.Context, params *ExpireClaimTypeParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewExpireClaimTypeRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateClaimTypeWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateClaimTypeRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateClaimType(ctx context.Context, body CreateClaimTypeJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateClaimTypeRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateOperationWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateOperationRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) CreateOperation(ctx context.Context, body CreateOperationJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewCreateOperationRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ResetDatabase(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewResetDatabaseRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewFindClaimRequest generates requests for FindClaim
func NewFindClaimRequest(server string, params *FindClaimParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/claim")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.ClaimID != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "claimID", runtime.ParamLocationQuery, *params.ClaimID); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ClaimType != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "claimType", runtime.ParamLocationQuery, *params.ClaimType); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ClaimKind != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "claimKind", runtime.ParamLocationQuery, *params.ClaimKind); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ClaimSubject != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "claimSubject", runtime.ParamLocationQuery, *params.ClaimSubject); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Claimant != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "claimant", runtime.ParamLocationQuery, *params.Claimant); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.AssociatedOperation != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "associatedOperation", runtime.ParamLocationQuery, *params.AssociatedOperation); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.AssociatedClaim != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "associatedClaim", runtime.ParamLocationQuery, *params.AssociatedClaim); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.RegistrationStart != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "registrationStart", runtime.ParamLocationQuery, *params.RegistrationStart); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.RegistrationEnd != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "registrationEnd", runtime.ParamLocationQuery, *params.RegistrationEnd); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ValidStart != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "validStart", runtime.ParamLocationQuery, *params.ValidStart); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.ValidEnd != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "validEnd", runtime.ParamLocationQuery, *params.ValidEnd); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Data != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "data", runtime.ParamLocationQuery, *params.Data); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateClaimRequest calls the generic CreateClaim builder with application/json body
func NewCreateClaimRequest(server string, body CreateClaimJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateClaimRequestWithBody(server, "application/json", bodyReader)
}

// NewCreateClaimRequestWithBody generates requests for CreateClaim with any type of body
func NewCreateClaimRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/claim")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewExpireClaimTypeRequest generates requests for ExpireClaimType
func NewExpireClaimTypeRequest(server string, params *ExpireClaimTypeParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/claimtype")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if queryFrag, err := runtime.StyleParamWithLocation("form", true, "claimType", runtime.ParamLocationQuery, params.ClaimType); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		if queryFrag, err := runtime.StyleParamWithLocation("form", true, "validEnd", runtime.ParamLocationQuery, params.ValidEnd); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("DELETE", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewCreateClaimTypeRequest calls the generic CreateClaimType builder with application/json body
func NewCreateClaimTypeRequest(server string, body CreateClaimTypeJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateClaimTypeRequestWithBody(server, "application/json", bodyReader)
}

// NewCreateClaimTypeRequestWithBody generates requests for CreateClaimType with any type of body
func NewCreateClaimTypeRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/claimtype")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewCreateOperationRequest calls the generic CreateOperation builder with application/json body
func NewCreateOperationRequest(server string, body CreateOperationJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewCreateOperationRequestWithBody(server, "application/json", bodyReader)
}

// NewCreateOperationRequestWithBody generates requests for CreateOperation with any type of body
func NewCreateOperationRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/operation")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

// NewResetDatabaseRequest generates requests for ResetDatabase
func NewResetDatabaseRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/reset")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("DELETE", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// FindClaimWithResponse request
	FindClaimWithResponse(ctx context.Context, params *FindClaimParams, reqEditors ...RequestEditorFn) (*FindClaimResponse, error)

	// CreateClaimWithBodyWithResponse request with any body
	CreateClaimWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateClaimResponse, error)

	CreateClaimWithResponse(ctx context.Context, body CreateClaimJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateClaimResponse, error)

	// ExpireClaimTypeWithResponse request
	ExpireClaimTypeWithResponse(ctx context.Context, params *ExpireClaimTypeParams, reqEditors ...RequestEditorFn) (*ExpireClaimTypeResponse, error)

	// CreateClaimTypeWithBodyWithResponse request with any body
	CreateClaimTypeWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateClaimTypeResponse, error)

	CreateClaimTypeWithResponse(ctx context.Context, body CreateClaimTypeJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateClaimTypeResponse, error)

	// CreateOperationWithBodyWithResponse request with any body
	CreateOperationWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateOperationResponse, error)

	CreateOperationWithResponse(ctx context.Context, body CreateOperationJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateOperationResponse, error)

	// ResetDatabaseWithResponse request
	ResetDatabaseWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*ResetDatabaseResponse, error)
}

type FindClaimResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ClaimFindResponse
	JSON400      *BadRequestErrorResponse
	JSON500      *InternalServerError
}

// Status returns HTTPResponse.Status
func (r FindClaimResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r FindClaimResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateClaimResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *ClaimCreateResponse
	JSON400      *BadRequestErrorResponse
	JSON500      *InternalServerError
}

// Status returns HTTPResponse.Status
func (r CreateClaimResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateClaimResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ExpireClaimTypeResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *EmptyResponse
	JSON400      *BadRequestErrorResponse
	JSON500      *InternalServerError
}

// Status returns HTTPResponse.Status
func (r ExpireClaimTypeResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ExpireClaimTypeResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateClaimTypeResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *ClaimTypeCreateResponse
	JSON400      *BadRequestErrorResponse
	JSON500      *InternalServerError
}

// Status returns HTTPResponse.Status
func (r CreateClaimTypeResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateClaimTypeResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type CreateOperationResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON201      *OperationCreateResponse
	JSON400      *BadRequestErrorResponse
	JSON500      *InternalServerError
}

// Status returns HTTPResponse.Status
func (r CreateOperationResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r CreateOperationResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ResetDatabaseResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON204      *EmptyResponse
	JSON500      *InternalServerError
}

// Status returns HTTPResponse.Status
func (r ResetDatabaseResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ResetDatabaseResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// FindClaimWithResponse request returning *FindClaimResponse
func (c *ClientWithResponses) FindClaimWithResponse(ctx context.Context, params *FindClaimParams, reqEditors ...RequestEditorFn) (*FindClaimResponse, error) {
	rsp, err := c.FindClaim(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseFindClaimResponse(rsp)
}

// CreateClaimWithBodyWithResponse request with arbitrary body returning *CreateClaimResponse
func (c *ClientWithResponses) CreateClaimWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateClaimResponse, error) {
	rsp, err := c.CreateClaimWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateClaimResponse(rsp)
}

func (c *ClientWithResponses) CreateClaimWithResponse(ctx context.Context, body CreateClaimJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateClaimResponse, error) {
	rsp, err := c.CreateClaim(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateClaimResponse(rsp)
}

// ExpireClaimTypeWithResponse request returning *ExpireClaimTypeResponse
func (c *ClientWithResponses) ExpireClaimTypeWithResponse(ctx context.Context, params *ExpireClaimTypeParams, reqEditors ...RequestEditorFn) (*ExpireClaimTypeResponse, error) {
	rsp, err := c.ExpireClaimType(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseExpireClaimTypeResponse(rsp)
}

// CreateClaimTypeWithBodyWithResponse request with arbitrary body returning *CreateClaimTypeResponse
func (c *ClientWithResponses) CreateClaimTypeWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateClaimTypeResponse, error) {
	rsp, err := c.CreateClaimTypeWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateClaimTypeResponse(rsp)
}

func (c *ClientWithResponses) CreateClaimTypeWithResponse(ctx context.Context, body CreateClaimTypeJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateClaimTypeResponse, error) {
	rsp, err := c.CreateClaimType(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateClaimTypeResponse(rsp)
}

// CreateOperationWithBodyWithResponse request with arbitrary body returning *CreateOperationResponse
func (c *ClientWithResponses) CreateOperationWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*CreateOperationResponse, error) {
	rsp, err := c.CreateOperationWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateOperationResponse(rsp)
}

func (c *ClientWithResponses) CreateOperationWithResponse(ctx context.Context, body CreateOperationJSONRequestBody, reqEditors ...RequestEditorFn) (*CreateOperationResponse, error) {
	rsp, err := c.CreateOperation(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseCreateOperationResponse(rsp)
}

// ResetDatabaseWithResponse request returning *ResetDatabaseResponse
func (c *ClientWithResponses) ResetDatabaseWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*ResetDatabaseResponse, error) {
	rsp, err := c.ResetDatabase(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseResetDatabaseResponse(rsp)
}

// ParseFindClaimResponse parses an HTTP response from a FindClaimWithResponse call
func ParseFindClaimResponse(rsp *http.Response) (*FindClaimResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &FindClaimResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ClaimFindResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseCreateClaimResponse parses an HTTP response from a CreateClaimWithResponse call
func ParseCreateClaimResponse(rsp *http.Response) (*CreateClaimResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateClaimResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest ClaimCreateResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseExpireClaimTypeResponse parses an HTTP response from a ExpireClaimTypeWithResponse call
func ParseExpireClaimTypeResponse(rsp *http.Response) (*ExpireClaimTypeResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ExpireClaimTypeResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest EmptyResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseCreateClaimTypeResponse parses an HTTP response from a CreateClaimTypeWithResponse call
func ParseCreateClaimTypeResponse(rsp *http.Response) (*CreateClaimTypeResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateClaimTypeResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest ClaimTypeCreateResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseCreateOperationResponse parses an HTTP response from a CreateOperationWithResponse call
func ParseCreateOperationResponse(rsp *http.Response) (*CreateOperationResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &CreateOperationResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 201:
		var dest OperationCreateResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON201 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ParseResetDatabaseResponse parses an HTTP response from a ResetDatabaseWithResponse call
func ParseResetDatabaseResponse(rsp *http.Response) (*ResetDatabaseResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ResetDatabaseResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 204:
		var dest EmptyResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON204 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalServerError
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Find claims
	// (GET /claim)
	FindClaim(w http.ResponseWriter, r *http.Request, params FindClaimParams)
	// Add a new claim
	// (POST /claim)
	CreateClaim(w http.ResponseWriter, r *http.Request)
	// expire a claim type
	// (DELETE /claimtype)
	ExpireClaimType(w http.ResponseWriter, r *http.Request, params ExpireClaimTypeParams)
	// add claim type
	// (POST /claimtype)
	CreateClaimType(w http.ResponseWriter, r *http.Request)
	// add operation
	// (POST /operation)
	CreateOperation(w http.ResponseWriter, r *http.Request)
	// Reset the database
	// (DELETE /reset)
	ResetDatabase(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Find claims
// (GET /claim)
func (_ Unimplemented) FindClaim(w http.ResponseWriter, r *http.Request, params FindClaimParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Add a new claim
// (POST /claim)
func (_ Unimplemented) CreateClaim(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// expire a claim type
// (DELETE /claimtype)
func (_ Unimplemented) ExpireClaimType(w http.ResponseWriter, r *http.Request, params ExpireClaimTypeParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// add claim type
// (POST /claimtype)
func (_ Unimplemented) CreateClaimType(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// add operation
// (POST /operation)
func (_ Unimplemented) CreateOperation(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Reset the database
// (DELETE /reset)
func (_ Unimplemented) ResetDatabase(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// FindClaim operation middleware
func (siw *ServerInterfaceWrapper) FindClaim(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params FindClaimParams

	// ------------- Optional query parameter "claimID" -------------

	err = runtime.BindQueryParameter("form", true, false, "claimID", r.URL.Query(), &params.ClaimID)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "claimID", Err: err})
		return
	}

	// ------------- Optional query parameter "claimType" -------------

	err = runtime.BindQueryParameter("form", true, false, "claimType", r.URL.Query(), &params.ClaimType)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "claimType", Err: err})
		return
	}

	// ------------- Optional query parameter "claimKind" -------------

	err = runtime.BindQueryParameter("form", true, false, "claimKind", r.URL.Query(), &params.ClaimKind)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "claimKind", Err: err})
		return
	}

	// ------------- Optional query parameter "claimSubject" -------------

	err = runtime.BindQueryParameter("form", true, false, "claimSubject", r.URL.Query(), &params.ClaimSubject)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "claimSubject", Err: err})
		return
	}

	// ------------- Optional query parameter "claimant" -------------

	err = runtime.BindQueryParameter("form", true, false, "claimant", r.URL.Query(), &params.Claimant)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "claimant", Err: err})
		return
	}

	// ------------- Optional query parameter "associatedOperation" -------------

	err = runtime.BindQueryParameter("form", true, false, "associatedOperation", r.URL.Query(), &params.AssociatedOperation)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "associatedOperation", Err: err})
		return
	}

	// ------------- Optional query parameter "associatedClaim" -------------

	err = runtime.BindQueryParameter("form", true, false, "associatedClaim", r.URL.Query(), &params.AssociatedClaim)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "associatedClaim", Err: err})
		return
	}

	// ------------- Optional query parameter "registrationStart" -------------

	err = runtime.BindQueryParameter("form", true, false, "registrationStart", r.URL.Query(), &params.RegistrationStart)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "registrationStart", Err: err})
		return
	}

	// ------------- Optional query parameter "registrationEnd" -------------

	err = runtime.BindQueryParameter("form", true, false, "registrationEnd", r.URL.Query(), &params.RegistrationEnd)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "registrationEnd", Err: err})
		return
	}

	// ------------- Optional query parameter "validStart" -------------

	err = runtime.BindQueryParameter("form", true, false, "validStart", r.URL.Query(), &params.ValidStart)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "validStart", Err: err})
		return
	}

	// ------------- Optional query parameter "validEnd" -------------

	err = runtime.BindQueryParameter("form", true, false, "validEnd", r.URL.Query(), &params.ValidEnd)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "validEnd", Err: err})
		return
	}

	// ------------- Optional query parameter "data" -------------

	err = runtime.BindQueryParameter("form", true, false, "data", r.URL.Query(), &params.Data)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "data", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.FindClaim(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateClaim operation middleware
func (siw *ServerInterfaceWrapper) CreateClaim(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateClaim(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ExpireClaimType operation middleware
func (siw *ServerInterfaceWrapper) ExpireClaimType(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params ExpireClaimTypeParams

	// ------------- Required query parameter "claimType" -------------

	if paramValue := r.URL.Query().Get("claimType"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "claimType"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "claimType", r.URL.Query(), &params.ClaimType)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "claimType", Err: err})
		return
	}

	// ------------- Required query parameter "validEnd" -------------

	if paramValue := r.URL.Query().Get("validEnd"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "validEnd"})
		return
	}

	err = runtime.BindQueryParameter("form", true, true, "validEnd", r.URL.Query(), &params.ValidEnd)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "validEnd", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ExpireClaimType(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateClaimType operation middleware
func (siw *ServerInterfaceWrapper) CreateClaimType(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateClaimType(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// CreateOperation operation middleware
func (siw *ServerInterfaceWrapper) CreateOperation(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.CreateOperation(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ResetDatabase operation middleware
func (siw *ServerInterfaceWrapper) ResetDatabase(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ResetDatabase(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/claim", wrapper.FindClaim)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/claim", wrapper.CreateClaim)
	})
	r.Group(func(r chi.Router) {
		r.Delete(options.BaseURL+"/claimtype", wrapper.ExpireClaimType)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/claimtype", wrapper.CreateClaimType)
	})
	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/operation", wrapper.CreateOperation)
	})
	r.Group(func(r chi.Router) {
		r.Delete(options.BaseURL+"/reset", wrapper.ResetDatabase)
	})

	return r
}

type BadRequestErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type ClaimCreateResponseJSONResponse struct {
	// Data The data returned after creating a claim
	Data *CreateClaimData `json:"data,omitempty"`
}

type ClaimFindResponseJSONResponse struct {
	// Data The list of found claims
	Data *FindClaimData `json:"data,omitempty"`
}

type ClaimTypeCreateResponseJSONResponse struct {
	// Data The data returned after creating a claim type
	Data *CreateClaimTypeData `json:"data,omitempty"`
}

type EmptyResponseJSONResponse map[string]interface{}

type InternalServerErrorJSONResponse struct {
	Errors []Error `json:"errors"`
}

type OperationCreateResponseJSONResponse struct {
	// Data The data returned after creating an operation
	Data *CreateOperationData `json:"data,omitempty"`
}

type FindClaimRequestObject struct {
	Params FindClaimParams
}

type FindClaimResponseObject interface {
	VisitFindClaimResponse(w http.ResponseWriter) error
}

type FindClaim200JSONResponse struct{ ClaimFindResponseJSONResponse }

func (response FindClaim200JSONResponse) VisitFindClaimResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type FindClaim400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response FindClaim400JSONResponse) VisitFindClaimResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type FindClaim500JSONResponse struct {
	InternalServerErrorJSONResponse
}

func (response FindClaim500JSONResponse) VisitFindClaimResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateClaimRequestObject struct {
	Body *CreateClaimJSONRequestBody
}

type CreateClaimResponseObject interface {
	VisitCreateClaimResponse(w http.ResponseWriter) error
}

type CreateClaim201JSONResponse struct {
	ClaimCreateResponseJSONResponse
}

func (response CreateClaim201JSONResponse) VisitCreateClaimResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(201)

	return json.NewEncoder(w).Encode(response)
}

type CreateClaim400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response CreateClaim400JSONResponse) VisitCreateClaimResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateClaim500JSONResponse struct {
	InternalServerErrorJSONResponse
}

func (response CreateClaim500JSONResponse) VisitCreateClaimResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type ExpireClaimTypeRequestObject struct {
	Params ExpireClaimTypeParams
}

type ExpireClaimTypeResponseObject interface {
	VisitExpireClaimTypeResponse(w http.ResponseWriter) error
}

type ExpireClaimType200JSONResponse struct{ EmptyResponseJSONResponse }

func (response ExpireClaimType200JSONResponse) VisitExpireClaimTypeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ExpireClaimType400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ExpireClaimType400JSONResponse) VisitExpireClaimTypeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ExpireClaimType500JSONResponse struct {
	InternalServerErrorJSONResponse
}

func (response ExpireClaimType500JSONResponse) VisitExpireClaimTypeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateClaimTypeRequestObject struct {
	Body *CreateClaimTypeJSONRequestBody
}

type CreateClaimTypeResponseObject interface {
	VisitCreateClaimTypeResponse(w http.ResponseWriter) error
}

type CreateClaimType201JSONResponse struct {
	ClaimTypeCreateResponseJSONResponse
}

func (response CreateClaimType201JSONResponse) VisitCreateClaimTypeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(201)

	return json.NewEncoder(w).Encode(response)
}

type CreateClaimType400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response CreateClaimType400JSONResponse) VisitCreateClaimTypeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateClaimType500JSONResponse struct {
	InternalServerErrorJSONResponse
}

func (response CreateClaimType500JSONResponse) VisitCreateClaimTypeResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type CreateOperationRequestObject struct {
	Body *CreateOperationJSONRequestBody
}

type CreateOperationResponseObject interface {
	VisitCreateOperationResponse(w http.ResponseWriter) error
}

type CreateOperation201JSONResponse struct {
	OperationCreateResponseJSONResponse
}

func (response CreateOperation201JSONResponse) VisitCreateOperationResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(201)

	return json.NewEncoder(w).Encode(response)
}

type CreateOperation400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response CreateOperation400JSONResponse) VisitCreateOperationResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type CreateOperation500JSONResponse struct {
	InternalServerErrorJSONResponse
}

func (response CreateOperation500JSONResponse) VisitCreateOperationResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

type ResetDatabaseRequestObject struct {
}

type ResetDatabaseResponseObject interface {
	VisitResetDatabaseResponse(w http.ResponseWriter) error
}

type ResetDatabase204JSONResponse struct{ EmptyResponseJSONResponse }

func (response ResetDatabase204JSONResponse) VisitResetDatabaseResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(204)

	return json.NewEncoder(w).Encode(response)
}

type ResetDatabase500JSONResponse struct {
	InternalServerErrorJSONResponse
}

func (response ResetDatabase500JSONResponse) VisitResetDatabaseResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Find claims
	// (GET /claim)
	FindClaim(ctx context.Context, request FindClaimRequestObject) (FindClaimResponseObject, error)
	// Add a new claim
	// (POST /claim)
	CreateClaim(ctx context.Context, request CreateClaimRequestObject) (CreateClaimResponseObject, error)
	// expire a claim type
	// (DELETE /claimtype)
	ExpireClaimType(ctx context.Context, request ExpireClaimTypeRequestObject) (ExpireClaimTypeResponseObject, error)
	// add claim type
	// (POST /claimtype)
	CreateClaimType(ctx context.Context, request CreateClaimTypeRequestObject) (CreateClaimTypeResponseObject, error)
	// add operation
	// (POST /operation)
	CreateOperation(ctx context.Context, request CreateOperationRequestObject) (CreateOperationResponseObject, error)
	// Reset the database
	// (DELETE /reset)
	ResetDatabase(ctx context.Context, request ResetDatabaseRequestObject) (ResetDatabaseResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// FindClaim operation middleware
func (sh *strictHandler) FindClaim(w http.ResponseWriter, r *http.Request, params FindClaimParams) {
	var request FindClaimRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.FindClaim(ctx, request.(FindClaimRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "FindClaim")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(FindClaimResponseObject); ok {
		if err := validResponse.VisitFindClaimResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// CreateClaim operation middleware
func (sh *strictHandler) CreateClaim(w http.ResponseWriter, r *http.Request) {
	var request CreateClaimRequestObject

	var body CreateClaimJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateClaim(ctx, request.(CreateClaimRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateClaim")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateClaimResponseObject); ok {
		if err := validResponse.VisitCreateClaimResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ExpireClaimType operation middleware
func (sh *strictHandler) ExpireClaimType(w http.ResponseWriter, r *http.Request, params ExpireClaimTypeParams) {
	var request ExpireClaimTypeRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ExpireClaimType(ctx, request.(ExpireClaimTypeRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ExpireClaimType")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ExpireClaimTypeResponseObject); ok {
		if err := validResponse.VisitExpireClaimTypeResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// CreateClaimType operation middleware
func (sh *strictHandler) CreateClaimType(w http.ResponseWriter, r *http.Request) {
	var request CreateClaimTypeRequestObject

	var body CreateClaimTypeJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateClaimType(ctx, request.(CreateClaimTypeRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateClaimType")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateClaimTypeResponseObject); ok {
		if err := validResponse.VisitCreateClaimTypeResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// CreateOperation operation middleware
func (sh *strictHandler) CreateOperation(w http.ResponseWriter, r *http.Request) {
	var request CreateOperationRequestObject

	var body CreateOperationJSONRequestBody
	if err := json.NewDecoder(r.Body).Decode(&body); err != nil {
		sh.options.RequestErrorHandlerFunc(w, r, fmt.Errorf("can't decode JSON body: %w", err))
		return
	}
	request.Body = &body

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.CreateOperation(ctx, request.(CreateOperationRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "CreateOperation")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(CreateOperationResponseObject); ok {
		if err := validResponse.VisitCreateOperationResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ResetDatabase operation middleware
func (sh *strictHandler) ResetDatabase(w http.ResponseWriter, r *http.Request) {
	var request ResetDatabaseRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ResetDatabase(ctx, request.(ResetDatabaseRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ResetDatabase")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ResetDatabaseResponseObject); ok {
		if err := validResponse.VisitResetDatabaseResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/9RaX2/juBH/KgTbhxZQZDt719vzU3NJCgQtdrfJ9h66CApGGtu8SKSOpJw1Fv7uBf9I",
	"oizapuxgd+/NlsiZ38xw/nH0BWe8rDgDpiSef8EVEaQEBcL8+70GsbmSkmeUKMivC0JL/TwHmQlaKcoZ",
	"nuO7G8QXKNMvkVoRhdSKSvdfwAIEsAxkihNM9XJDFCeYkRLwHJMd8gmW2QpKovn8WcACz/GfJh3IiX0r",
	"J4b+3Q3ebpNdnO8rEMSC28XKm1eo44teqFohtQKL+TjQjn4s2JatD/jaSXBYoRwJULVg+2A1ejhZbwbG",
	"PynLh0D007FQDKVRYMyOPpyH+uk3yNRh1Ui7KBJXQzIWmqM+0NTHTQX7NaU2FUQCMoRGKUrveKcpDBHd",
	"w+81FZDHIkN/EW7HX2NAipa8EjW8BmjCAtbN3BuD95g/NovH6ZCwnklviCJDHDlRBHFjf6l1tqCFAoGM",
	"w4eg6PXjYGi+/zZEWij3sKRS2TBxG/JGrRHhLULAcpQTBVHqEjvkY+FqBmGQD4oIFQFT6nWnAbUsToP6",
	"KylovleRa/12nAbXDcHz8Ox31SO4InzWg3iaywYgHzCzBTvSvuuO6EhUWysVSPULzymYEsUEk3v7VP/P",
	"OFNgYwupqoJm5hxNfpO2Guj4VUInZeXIUFbV6hgMW6A0MKxyP7mtjwlWJjNgGzcs3L7KrpwdMwHWM+zS",
	"dGCtbYJ7kf1ryWai/fnymVQTI2RbSH0lIbvC7QwhGeqKyONCGj6y4kxanL+Q3Al7KwQX9+7dGZKDpmN1",
	"oKCUx3Rg2OJtKykRgmwG+nBEYxRyx2wYMCpEstbQIU9xc4ivtY7gFQTNXa4+eIwNs+smxRq5jkrwUGcZ",
	"SLmoi860Lfx/UB2yvwp4zeo1oWt3/lba17zPF+O2rNTmJPBHWb7jakXZEjGA3BR5T+BqY3d475gCwUjx",
	"AGINwrrNH9dLP64ASSMJApbxWgsHOSIM1Qw+V5DpRtjQM8K3kfIbnJ+W97nnZ9vUF12lMKxjmqRFWVbU",
	"uT4RVEnkKvq+CGR4ExLVaSe2V/nfs2uyIzviZptyHeeIVivpuqMRTVESZaSsi1BJoFiPKuUSLLsOP7IL",
	"T/zKMbaM9b1FtjcAXuvoWaan76Rp6oYSDt3NSxVNQ0mK4v0Czz9FVZTJrrMQxrgiirKlWREfN3Y2Nmbq",
	"R5EkeJc15gorwTQfcfzFsLWNOSNrr4OLsvaOWR5DQdD09oTlqARFbKO/QAQteM1yGwp6+XN/wDBVbj9q",
	"WEAohwVl1F0Q9g1re6CRvtyFVJLnhi4pPnhkbYMHn0lZFTCMvGvOhebLvLwolaBsOVRagreB0z3OEGc7",
	"qlFSK3bQ3XbKvIGRWks3KR2RhQLhCna2RMTZetdAI871bguRH4Pa1kQnw0UuNp2EWbMfi7ufi0/A7XVL",
	"J+DevTePwN0WakOkpryxIwqeZbXQBdDLihaAKsF1/aARm+GFu2ZIB5BLkJIsjZO1/oYXnKMXYAq9CM6W",
	"OAk4mQ+8oRFC328BglIUVJoLUi9iSZzEpYd+mgokhgOjkyuU8aKAzPa7CySgMNOTFkFfU6cVIFmb7lr1",
	"fnocI1xIqPYUfYyopPqLzylxzoyCXpHSx5QEr0h712pOjaETFqoQgufs2Q0OXiFSJnhk6RtKQpkPN5wI",
	"v2z3ZnxLpy+PlzEJns8S/GTGfPkCH+Rv7+0HOtMNkOmtcsgdO58HHsaFpB3eBQ1gjYiorkwXXJRE4Tmu",
	"a/M/TCk8xWtpIVfmAqtLfcKupNSaM5HZXPU2YfqaC2EdHSf4Hha1at7cfq6oAH8K0D40FLwjt4PNZZ8D",
	"6GxBFS9tWyIdodmzwq9tMbSPrI1FQZo0b264gSmqNqgkzzZnQHuojmI3zh6Irvr5RNESUMlLnU0oQ3cP",
	"79/+bTrrSTD7+ae3F9MfL6azj7Of55ez+eWbdDr9r89ak7rQpEL8/ZwalLJdEHv2BvH1AM3WIu4MPigo",
	"3hFS3rHg0en6vziDmOROpXnUzIf9ocRxcXTsoWzBm6sOYptUKAkttGrpkhbk6e9rtkxZgQMBh0oNgKBr",
	"9wGEdhUQ6OrDnS4nCpqBu0hx85Db/3z4F5qllzjBtdAsVkpVcj6ZQF0VKdSTWXo5ATYxQYkqcwaGtHUG",
	"ACEtiFk6TafOMoxUFM/xm3SavtExnKiVCd823OpfSwiMd+5NQScRKYomEJVEZavmuJuhTurnprscz7v6",
	"xbDqviXZ0wd3Sya9TyJ0Rxy93iXqETvc/cqIHc3XA6M26eQduyH09cr4vd19Qsy+4TD3lJ23I3TpDRRH",
	"bRnDw5a2jztzl8vpdF/90a6bDC/8twn+IWbnvrHONsE/xuwPXTab+8u6LImuNoxndbW2IkvZFon4cZvg",
	"isugG9sQoQMSg5f2rtMGyI1UUA6d2GtZsT9y3eyXw5vKTnoj2e3ADrNIO+zcPH8/lrjKc1+bAWtsExde",
	"VZsQCwhlfVs5oXaWrlNYV6I2ubJvHbvn2vs659RA2/twaKw/dhtPcrX+ZOf7MS5Yi+xYoGfgC/Nwv891",
	"56Nf9SDFndspKA85nffR1XjH878ZON35AqPD78dGJM8jzKOdkPvXGXERsrNZL0rusZf/Kehoew0+fzjJ",
	"XvtGdd+XvfxbwMZc3TNrLQGyKUXD4fLGPO8VpYTlvYbF2ky3/E9EwjC33WseN+41Huj7hxMi1ytpySDr",
	"ofdUpUAq3Z48mv7EDnJttO/3DFYrKakqmbpWJWWgXrh4nqynJsh3G5r1F08kewaWX8wuf9KdQzpLGa1S",
	"yudvp2+nZt9jC2XQhllkSPBa2a+8XV/TQNY8d7LeGsTGTt/JE69VY0vtuD4Fz52jiexuj9nZnR9vtzdH",
	"ftz+PwAA///so3rtJy8AAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
